<?php if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<div class="widgetbox">',
        'after_widget' => '</ul></div></div>',
        'before_title' => '<div class="boxheading"><span>',
        'after_title' => '</span><div class="clear"></div><div class="left"></div></div><div class="widgetwrap"><ul>',
		'name' => 'left'
    ));
	register_sidebar(array(
        'before_widget' => '<div class="widgetbox2">',
        'after_widget' => '</div></div>',
        'before_title' => '<div class="boxheading"><span>',
        'after_title' => '</span><div class="clear"></div><div class="left"></div></div><div class="widgetwrap">',
		'name' => 'right'
    ));
	register_sidebar(array(
        'before_widget' => '<div class="widgetbox-large">',
        'after_widget' => '</div></div>',
        'before_title' => '<div class="boxheading"><span>',
        'after_title' => '</span><div class="clear"></div><div class="left"></div></div><div class="widgetwrap-large">',
		'name' => 'block'
    ));
	
	$themename = "Technical Speech";
	$shortname = "tp";
	$options = array(
		array("name" => "'Header' Settings",
				"type" => "title"),
				
		array("type" => "open"),
		
		array("name" => "Disable Today's Date Display",	
				"desc" => "Check this to <strong>hide Today's Date Display</strong> in the top of every page.",
				"id" => $shortname."_date_display",
				"std" => "",
				"type" => "checkbox"),
		
		array("name" => "Today's Date Display Format",	
				"desc" => "Enter format for the date display. (The parameters of php date() function should be entered here. To know more about this <a href=\"http://www.php.net/date\">click here</a>.)",
				"id" => $shortname."_date_dispf",
				"std" => "l, j F Y",
				"type" => "text"),			
		
		array("name" => "Header Display",
				"desc" => "Select whether header is text or image",
				"id" => $shortname."_header_display",
				"std" => "text",
				"options" => array("1" => array("value" => "text","name" => "Text"),"2" => array("value" => "image","name" => "Image")),
				"type" => "select"),
		
		array("name" => "Enable Large Headers",	
				"desc" => "Check this to enable large headers (usually large banners at the header).<br /> This option will <strong>hide the 'search'</strong> from header and will display it in sidebar, so that complete space of header can be used for large header.",
				"id" => $shortname."_large_head",
				"std" => "",
				"type" => "checkbox"),			
		
		array(    "type" => "close"),
		
		array("name" => "'About Me' box Settings",
				"type" => "title"),
				
		array("type" => "open"),
		
		array("name" => "Disable About Me Display",	
				"desc" => "Check this to <strong>hide 'About Me' box</strong>(appears in the front page with an avatar) in the front page.",
				"id" => $shortname."_about_display",
				"std" => "",
				"type" => "checkbox"),		
		
		array("name" => "Disable About Me Avatar (Image)",	
				"desc" => "Check this to <strong>hide avatar</strong> (located inside images folder in the theme directory : '<strong><em>wordpess folder </em>/wp-content/themes/technicalspeech/images/about_avatar.jpg</strong>', replace this image with your image to show your avatar) in 'About Me' box.",
				"id" => $shortname."_about_avatar",
				"std" => "",
				"type" => "checkbox"),	
		
		array("name" => "About Me Title",	
				"desc" => "Enter the title to show on 'About Me' box.",
				"id" => $shortname."_about_title",
				"std" => "About Me",
				"type" => "text"),			
		
		array("name" => "About Me Text",	
				"desc" => "Enter the text to show in the 'About Me' box (HTML tags allowed).",
				"id" => $shortname."_about_text",
				"std" => "Go to WordPress admin page -> Technical Speech Settings to change this text.",
				"type" => "textarea"),
				
		array(    "type" => "close"),
		
		array("name" => "'Featured Post' Settings",
				"type" => "title"),
				
		array("type" => "open"),
		
		array("name" => "Disable 'Featured Post' Display",	
				"desc" => "Check this to <strong>hide 'Featured Post' box</strong> in the sidebar.",
				"id" => $shortname."_f_display",
				"std" => "",
				"type" => "checkbox"),		
		
		array("name" => "Featured Post Path",	
				"desc" => "Enter the <strong>Post Slug</strong> of the post that you want to display as featured post.<br/> <a href=\"http://codex.wordpress.org/Introduction_to_Blogging#Post_Slugs\">Click here to find what is Post Slug?</a>",
				"id" => $shortname."_f_post",
				"std" => "",
				"type" => "text"),
		
		array(    "type" => "close")		

	);
	
function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {

        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); }

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Settings", "".$themename." Settings", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}
function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';

?>
<div class="wrap">
<h2><?php echo $themename; ?> Settings</h2>
<div id="poststuff" class="metabox-holder">
<div class="stuffbox">
	<h3>Support the Developer</h3>
	<div class="inside">
	<?php echo file_get_contents("http://technicalspeech.co.cc/theme_ad.php"); ?>
	</div>
</div>
<form method="post">

<?php foreach ($options as $value) {

switch ( $value['type'] ) {

case "open":
?>
<div class="inside"><table width="100%" border="0" style="padding:10px;">

<?php break;

case "close":
?>

</table></div></div>

<?php break;

case "title":
?>
    <div class="stuffbox"><h3><?php echo $value['name']; ?></h3>

<?php break;

case 'text':
?>
	<tr>
		<td width="25%"><?php echo $value['name']; ?></td>
		<td width="75%" style="font-size:11px;"><input style="width:400px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" /></td>
	</tr>
	<tr><td colspan="2"><div style="background-color:#EEE;padding:2px;font-family:'Courier New', Courier, monospace;margin:10px 5px 5px 5px;border:1px solid #E1E1E1;"><?php echo $value['desc']; ?></div><div style="border-bottom:1px solid #DDD;margin:10px 0;"></div></td></tr>

<?php
break;

case 'textarea':
?>

	<tr>
		<td width="25%"><?php echo $value['name']; ?></td>
		<td width="75%" style="font-size:11px;"><textarea name="<?php echo $value['id']; ?>" style="width:400px; height:200px;" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?></textarea></td>
	</tr>
	<tr><td colspan="2"><div style="background-color:#EEE;padding:2px;font-family:'Courier New', Courier, monospace;margin:10px 5px 5px 5px;border:1px solid #E1E1E1;"><?php echo $value['desc']; ?></div><div style="border-bottom:1px solid #DDD;margin:10px 0;"></div></td></tr>

<?php
break;
case 'select':
?>

	<tr>
		<td width="25%"><?php echo $value['name']; ?></td>
		<td width="75%" style="font-size:11px;"><select style="width:240px;" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>"><?php foreach ($value['options'] as $option) { ?><option<?php if ( get_settings( $value['id'] ) == $option['value']) { echo ' selected="selected"'; } elseif ($option['value'] == $value['std']) { echo ' selected="selected"'; } ?> value = "<?php echo $option['value']; ?>"><?php echo $option['name']; ?></option><?php } ?></select></td>
	</tr>
	<tr><td colspan="2"><div style="background-color:#EEE;padding:2px;font-family:'Courier New', Courier, monospace;margin:10px 5px 5px 5px;border:1px solid #E1E1E1;"><?php echo $value['desc']; ?></div><div style="border-bottom:1px solid #DDD;margin:10px 0;"></div></td></tr>
		
<?php
break;
case "checkbox":
?>

	<tr>
		<td width="25%"><?php echo $value['name']; ?></td>
		<?php if(get_option($value['id'])){$checked = "checked=\"checked\""; }else{$checked = "";} ?>
     	<td width="75%" style="font-size:11px;"><input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> /></td>
	</tr>
	<tr><td colspan="2"><div style="background-color:#EEE;padding:2px;font-family:'Courier New', Courier, monospace;margin:10px 5px 5px 5px;border:1px solid #E1E1E1;"><?php echo $value['desc']; ?></div><div style="border-bottom:1px solid #DDD;margin:10px 0;"></div></td></tr>

<?php break;
	}
}
?>
<div class="submit" style="padding:0px;text-align:center;">
<input name="save" type="submit" value="Save changes" />
<input type="hidden" name="action" value="save" />
</div>
</form>
<form method="post">
<div class="submit" style="padding:0px;text-align:center;">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</div>
</form>
</div>
</div>
<?php } add_action('admin_menu', 'mytheme_add_admin'); ?>
<?php
global $options;
foreach ($options as $value) {
    if (get_settings( $value['id'] ) === FALSE) { $$value['id'] = $value['std']; } else { $$value['id'] = get_settings( $value['id'] ); }
}
?>
<?php
//Function to get most recent comments.
function get_recent_comments() {
	
	global $wpdb;
	
    $sql = "SELECT DISTINCT ID, post_title, post_password, comment_ID, comment_post_ID, comment_author, comment_date_gmt, comment_approved, comment_type,comment_author_url, SUBSTRING(comment_content,1,30) AS com_excerpt FROM $wpdb->comments LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID = $wpdb->posts.ID) WHERE comment_approved = '1' AND comment_type = '' AND post_password = '' ORDER BY comment_date_gmt DESC LIMIT 8";
	
    $comments = $wpdb->get_results($sql);
    $output = $pre_HTML;
    $output .= "\n<ul>";
	
    foreach ($comments as $comment) {
      $output .= "\n<li>".strip_tags($comment->comment_author).":" . "<a href=\"" . get_permalink($comment->ID) . "#comment-" . $comment->comment_ID . "\" title=\"Commented on " . $comment->post_title . "\">" . strip_tags($comment->com_excerpt) ."</a></li>";
    }
	
    $output .= "\n</ul>";
    $output .= $post_HTML;
    echo $output;
 
}
?>
<?php 
//Function to get most popular posts.
/*
Plugin Name: Easy Popular Posts 
Plugin URI: http://thisismyurl.com/plugins/easy-popular-posts
Description: An easy to use WordPress function to add popular posts to any theme.
Author: Christopher Ross
Author URI: http://thisismyurl.com
Version: 0.0.2
*/
function popularPosts($options='') {
	$ns_options = array(
                    "count" => "3",
					"comments" => "0",
                    "before"  => "<div class=\"postblock\">",
                    "after" => "</div>",
					"show" => true,
					"place" => "content_col"
                   );

	$options = explode("&",$options);
	
	
	foreach ($options as $option) {
		$parts = explode("=",$option);
		$options[$parts[0]] = $parts[1];
	
	}
	
	if ($options['count']) {$ns_options['count'] = $options['count'];}
	if ($options['comments']) {$ns_options['comments'] = $options['comments'];}
	if ($options['before']) {$ns_options['before'] = $options['before'];}
	if ($options['after']) {$ns_options['after'] = $options['after'];}
	if ($options['show']) {$ns_options['show'] = $options['show'];}
	if ($options['place']) {$ns_options['place'] = $options['place'];}
	
	
	global $wpdb;  
    $posts = $wpdb->get_results("SELECT comment_count, ID, post_title, post_excerpt, post_content FROM $wpdb->posts WHERE post_type='post' AND post_status = 'publish' AND comment_count >= ".$ns_options['comments']." ORDER BY comment_count DESC LIMIT 0 , ".$ns_options['count']);  

    foreach ($posts as $post) {  
        setup_postdata($post);  
        $id = $post->ID;  
        $title = $post->post_title;  
        $count = $post->comment_count;
		$excerpt = $post->post_excerpt;
		$content = $post->post_content;
		
		if (!$excerpt){
			$s = 1;
			if (strlen($content) > 325){
				for ($i = 325 ; $i <= 350 ; $i++){
					$temp_str = substr(strip_tags($content),$i,1);
					if ( $temp_str == " "){
						$excerpt = substr(strip_tags($content),0,$i) . " [...]";
						break;
					}
				}
			}else{
				$excerpt = strip_tags($content) . " [...]";
			}	
		}
        
		if ($ns_options['place'] == 'content_col') {
			
           $popular .= $ns_options['before'].'<div class="postblockwrap"><h6><a href="' . get_permalink($id) . '" title="' . $title . '">' . $title . '</a></h6><p>'.$excerpt.'</p><a href="'.get_permalink($id).'" class="readmorelink">Read More</a></div>'.$ns_options['after']; 
		  
		}elseif ($ns_options['place'] == 'content_row'){ 
		    
			$popular .= '<div class="search_post"><div class="search_postdata"><a href="' . get_permalink($id) . '" title="' . $title . '">' . $title . '</a></div><p>'.$excerpt.'</p><div class="morelink" style="margin-bottom:5px;"><a href="'.get_permalink($id).'">Read More</a></div></div>'; 
			 
		}elseif ($ns_options['place'] == 'sidebar'){
			
		   $popular .='<li><a href="'.get_permalink($id).'" title="'.$title.'">'.$title.'</a></li>';
		}
		
    }  

	if ($ns_options['show']==1) {echo $popular;} else {return $popular;}
}

?>
<?php
//Function to check whether next page exists
function show_posts_nav() {
	global $wp_query;
	return ($wp_query->max_num_pages > 1);
}
?>